int dec,uni,decimal,dato,aux;
int const disp[10]  = {0x3F, 0x06, 0x5B, 0x4F,                 //Se declaran como constantes
                       0x66, 0x6D, 0x7D, 0x07, 0x7F, 0x6F};   //Codigo Hexa para cada nuemro 
int const id[27] = {0X77,0X7C,0X39,0X5E,0x79,0x71,0x3d,0x76,0x06,0x1e,0x76,0x38,0x4F,0x54,0x55,0x5c,0x73,0x67,0x50,0x6d,0x70,0x1c,0x3e,0x4f,0x76,0x6e,0x5b};
                  // A  , B  , C  , D  , E  , F  , G  , H  , I  , J  , K  , L  , M  , N  ,   , O  , P  , Q  , R  , S  , T  , U  , V  , W  , X  , Y  , Z
                  // 0  , 1  , 2  , 3  , 4  , 5  , 6  , 7  , 8  , 9  , 10 , 11 ,12  ,13  ,14  ,15  ,16  ,17  ,18  ,19  ,20  ,21  ,22  ,23  ,24  ,25  ,26

int espejo(int temp1)                //Funcion Para invertir Bits de una variable
{ int temp2=0;
if ((temp1&0x01)==0x01)
temp2=temp2+128;
if ((temp1&0x02)==0x02)
temp2=temp2+64;
if ((temp1&0x04)==0x04)
temp2=temp2+32;
if ((temp1&0x08)==0x08)
temp2=temp2+16;
if ((temp1&0x10)==0x10)
temp2=temp2+8;
if ((temp1&0x20)==0x20)
temp2=temp2+4;
if ((temp1&0x40)==0x40)
temp2=temp2+2;
if ((temp1&0x80)==0x80)
temp2=temp2+1;
return temp2;
}

void p1()
{ 

ADC_Init();                                //inicializo el ADC
while(1)
{

dato=ADC_Read(0);       //entrada analogica 0

aux=(dato/10.23);                  //division perfecta para marcar rango 
if(aux<=99)
{
dec=aux/10;                       //division para extraer decimal del dato anterior
uni=aux%10;                      //modulo (residuo de la division) para extraer unidades
}
if(aux==100)
{
dec=0;
uni=0;
}
PORTB=espejo(aux);                // muestro el valor binario en el PORTB
PORTC=disp[uni];                // muestro valor unidaades en el PORTC.
PORTD=disp[dec];                // muestro valor decenas en el PORTD



}
}

void p2()
{
int contu=0, contd=0, contt=0;        //declaracion de variables

do{                                                                //se enceran displays
PORTC=disp[0];
PORTD=disp[0];
}while(PORTA.F2);                                // se valida que suelte la resistencia


while(1)
{
 contt=(contd*10)+contu;
 
 if(PORTA.F1)                                        // si presiona la botonera PORTA.pin1
 {
 contu++;                                                // incremento unidades

 if(contu==10)                                        // valido que cuando pase de 10 se incremente decenas y unidades
 { contu=0;
   contd++;
   if(contd==10)
   { contu=0;
     contd=0;
   }
 }

Delay_ms(300);
}

 if(PORTA.F2)                                        //si presiona la botonera PORTA.Pin2 
 {
 contd++;                                                // se incrementas decenas

 if (contd==10)                                        // se valida el paso por 9
 { contd=0;
   contu=0;
 }

Delay_ms(300);
}

 if(PORTA.F3)                                        //si presiona la botonera PORTA.pin3
 {
  contt--;                                                // se decrementa el contador total.
  if(contt==0)                                        // se valida al contador
  contt=0;
  contu=contt%10;
  contd=contt/10;
  Delay_ms(300);
 }

 if(PORTA.F4)                                         // si presiona la PORTA.Pin4
 {
 while(contt>0)                                        // mientras no sea cero lo decremeta
 {
 Delay_ms(1000);
 contt--;
 contu=contt%10;                                //se las separa nuevamente y se los
 contd=contt/10;                                // digitos en unidades y decenas
 PORTC=disp[contu];                                //se muestran unidades en el PORTC
 PORTD=disp[contd];                                // se muestran decenas en el PORTD

 }
 
 PORTB=0xFF;                                        // se hace parpadear todos los ledd
 Delay_ms(500);
 PORTB=0x00;
 Delay_ms(500);
 PORTB=0xFF;
 Delay_ms(500);
 PORTB=0x00;
 Delay_ms(500);
 PORTB=0xFF;
 Delay_ms(500);
 PORTB=0x00;
 Delay_ms(500);

 
 
}

PORTC=disp[contu];                                // Se muestran los valores/ tiempo total en march
PORTD=disp[contd];                

}
}

void main()
{
ANSEL=0x01;
ANSELH = 0;                 // Configure other AN pins as digital I/O
C1ON_bit = 0;               // Disable comparators
C2ON_bit = 0;
TRISA  = 0xFF;              // PORTA como entrada
TRISC  = 0;                 // PORTC como salida
TRISB  = 0;                 // PORTB como salida
TRISD  = 0;                                        // PORTD como salida

PORTB=0;                                        // inicializado en 0 el PORTB
PORTC=id[0];                                // iniciales
PORTD=id[7];                                // iniciales

while(1)
{
if(RA1_bit=1)                                //prueba el bit 1 del PORTA
p1();
if(PORTA.F2=1)                                //prueba el bit 2 del PORTA
p2();
}

}